unit ErrSignal;

{ Copyright  1989, 1991 David B. Lamkins							}

{ This unit is adapted by David B. Lamkins from Apples Macintosh	}
{ Technical Note #88 by Rick Blair.	  See the documentation			}
{ accompanying this unit for a detailed description. 					}

interface

	const
		sigFail = 200;		{ May be used as argument to InitSignals		}

	procedure InitSignals (failCode: Integer);

	function CatchSignal: Integer;
	procedure FreeCatch;

	procedure SignalHandlerDone;
	procedure TerminateSignalHandler;

	procedure Signal (code: Integer);
	procedure SignalWhen (code: Integer; condition: Boolean);
	procedure SignalUnless (code: Integer; condition: Boolean);
	procedure SignalMem;
	procedure SignalRes;
	procedure SignalNIL (p: univ Ptr);
	procedure SignalNILRes (h: univ Handle);

	procedure ReSignal;
	procedure PassSignal (code: Integer);
	procedure PassMemSignal;
	procedure PassResSignal;

	function IdentifySignaller: Longint;
	function LastSignalCode: Integer;
	function HandlingSignal: Boolean;
	function CatchInBlock: Boolean;
	function CatchDepth: Integer;

	procedure TrimCatchMemory;

	const
		esStopInTHINKProject = 128;
		esStopInApplication = 64;
		esStopAtSignal = 4;
		esStopAtReSignal = 2;
		esStopAtError = 1;
	function SetSignalStops (stopsMask: Integer): Integer;

	function RegisterCleanupAction (p: ProcPtr): Integer;
	procedure Cleanup (value: univ Longint; action: Integer);

	procedure Ignore (value: univ Longint);

implementation

{ all routines are external }

end.